#!/usr/bin/env bash

# demangle_libtool expects a series of .la files as input 
# purpose:
#   To use the CROSS_COMPILE_PREFIX variable in libdir
#   To get rid of explicit, static .la and library paths 

# Copyright 2002 Michael Taht <mike@ackley.net>
# Copyright 2002 MontaVista Software <source@mvista.com>
# Released under the terms of the GNU Public license version 2 and later

TEMPFILE=/tmp/newlibtool.$$

if [ $# -gt 0 ]; then
echo -n "Preparing libtool libraries for cross-compilation: "
fi

while [ $# -gt 0 ]
do
arg=$1
shift
	newdeps=
	. $arg
	echo -n "$arg " 
	for i in $dependency_libs
	do
	case $i in
		-l*)   newdeps="$newdeps\n$i";; # great, do nothing
		*.la)  z=`basename $i`; 
		       n=1
		       y=`echo $z | cut -f$n -d. --`
		       while [ "$y" != "la" ]
			do
			n=`expr $n + 1`
		        y=`echo $z | cut -f$n -d. -- `
		        done; 
		        n=`expr $n - 1`;
			if [ $n -lt 1 ]; then n=1; fi;
		        z=`echo $z | cut -f1-$n -d. -- | cut -f2- -db --`;
		        newdeps="$newdeps\n-l$z";;
		*.so*) z=`basename $i`;
		       n=1;
		       y=`echo $z | cut -f$n -d. --`;
		       while [ "$y" != "so" ]
			do
			n=`expr $n + 1`
		        y=`echo $z | cut -f$n -d.`
		        done;
		       n=`expr $n - 1`;
			if [ $n -lt 1 ]; then n=1; fi;
		       z=`echo $z | cut -f1-$n -d. -- | cut -f2- -db --`;
		       newdeps="$newdeps\n-l$z";;
	esac
	
	done
	newdeps=`echo -e $newdeps | sort -u | xargs /bin/echo`
	newpre='libdir=\$CROSS_COMPILE_PREFIX'
	deplibs="dependency_libs=\' $newdeps\'"

# Brain damage in sed and bash made me write this in perl
        perl -p -e s,dependency_libs.*,"$deplibs", $arg > $TEMPFILE
# Brain damage in perl and bash made me write this in sed
#       perl -pi -e s,libdir=.*,"$newpre$(1)", /tmp/new 
	sed -- s,libdir=,libdir=\$CROSS_COMPILE_PREFIX, $TEMPFILE > $arg
	if [ -s $arg ]; then
	:
	else
	echo "... failed."
	exit -1
	fi

done
	echo "... complete."
	rm $TEMPFILE
#	echo $newdeps
